<template>
  <div class="notification-area">
    <transition-group name="fade">
      <notification-box
        v-for="notification in notifications"
        :key="notification"
        :title="notification.title"
        :type="notification.type"
        @destroy="closeNotification(notification)"
        :html="notification.text"
      />
    </transition-group>
  </div>
</template>

<script>
import NotificationBox from "@/components/NotificationBox";

export default {
  name: "NotificationArea",
  components: { NotificationBox },
  data() {
    return {
      notifications: [],
    };
  },
  methods: {
    closeNotification(notification) {
      this.notifications = this.notifications.filter(
        (not) => not !== notification
      );
    },
    createNotification(text, title, type) {
      for (const notification of this.notifications) {
        if (notification.text === text && notification.title === title) return;
      }
      this.notifications.push({
        text: text || null,
        title: title || null,
        type: type || null,
      });
    },
  },
};
</script>

<style lang="scss">
.notification-area {
  position: fixed;
  top: 0;
  right: 0;
  width: 100vw;
  height: 100vh;
  max-width: 450px;
  margin-top: 1rem;
  margin-right: 0.5rem;
  z-index: 7000;
  pointer-events: none;
}
</style>
